package com.ruoyi.system.controller;

import org.springframework.web.bind.annotation.DeleteMapping;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.core.web.domain.AjaxResult;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.GetMapping;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import java.util.Iterator;
import java.util.Collection;
import java.util.List;
import java.util.Collections;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.system.api.model.LoginUser;
import com.ruoyi.system.domain.SysUserOnline;
import java.util.ArrayList;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.redis.service.RedisService;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.system.service.ISysUserOnlineService;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.core.web.controller.BaseController;

@RestController
@RequestMapping({ "/online" })
public class SysUserOnlineController extends BaseController
{
    @Autowired
    private ISysUserOnlineService userOnlineService;
    @Autowired
    private RedisService redisService;
    
    @RequiresPermissions({ "monitor:online:list" })
    @GetMapping({ "/list" })
    public TableDataInfo list(final String ipaddr, final String userName) {
        final Collection<String> keys = this.redisService.keys("login_tokens:*");
        final List<SysUserOnline> userOnlineList = new ArrayList<SysUserOnline>();
        for (final String key : keys) {
            final LoginUser user = (LoginUser)this.redisService.getCacheObject(key);
            if (StringUtils.isNotEmpty(ipaddr) && StringUtils.isNotEmpty(userName)) {
                userOnlineList.add(this.userOnlineService.selectOnlineByInfo(ipaddr, userName, user));
            }
            else if (StringUtils.isNotEmpty(ipaddr)) {
                userOnlineList.add(this.userOnlineService.selectOnlineByIpaddr(ipaddr, user));
            }
            else if (StringUtils.isNotEmpty(userName)) {
                userOnlineList.add(this.userOnlineService.selectOnlineByUserName(userName, user));
            }
            else {
                userOnlineList.add(this.userOnlineService.loginUserToUserOnline(user));
            }
        }
        Collections.reverse(userOnlineList);
        userOnlineList.removeAll(Collections.singleton((Object)null));
        return this.getDataTable((List)userOnlineList);
    }
    
    @RequiresPermissions({ "monitor:online:forceLogout" })
    @Log(title = "在线用户", businessType = BusinessType.FORCE)
    @DeleteMapping({ "/{tokenId}" })
    public AjaxResult forceLogout(@PathVariable final String tokenId) {
        this.redisService.deleteObject("login_tokens:" + tokenId);
        return this.success();
    }
}
